'use strict';

exports.__esModule = true;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getSnapshot = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(selector, callsite) {
        var node;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        node = null;
                        _context.prev = 1;
                        _context.next = 4;
                        return selector();

                    case 4:
                        node = _context.sent;
                        _context.next = 11;
                        break;

                    case 7:
                        _context.prev = 7;
                        _context.t0 = _context['catch'](1);

                        _context.t0.callsite = callsite;
                        throw _context.t0;

                    case 11:
                        if (node) {
                            _context.next = 13;
                            break;
                        }

                        throw new _testRun.CantObtainInfoForElementSpecifiedBySelectorError(callsite);

                    case 13:
                        return _context.abrupt('return', node);

                    case 14:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[1, 7]]);
    }));

    return function getSnapshot(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

exports.default = createSnapshotPropertyShorthands;

var _snapshotProperties = require('./snapshot-properties');

var _testRun = require('../../errors/test-run');

var _callsite = require('../../errors/callsite');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SNAPSHOT_PROPERTIES = _snapshotProperties.NODE_SNAPSHOT_PROPERTIES.concat(_snapshotProperties.ELEMENT_SNAPSHOT_PROPERTIES);

function createSnapshotPropertyShorthands(obj, selector) {
    var _this = this;

    SNAPSHOT_PROPERTIES.forEach(function (prop) {
        (0, _defineProperty2.default)(obj, prop, {
            get: function () {
                var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
                    var callsite, snapshot;
                    return _regenerator2.default.wrap(function _callee2$(_context2) {
                        while (1) {
                            switch (_context2.prev = _context2.next) {
                                case 0:
                                    callsite = (0, _callsite.getCallsiteForGetter)();
                                    _context2.next = 3;
                                    return getSnapshot(selector, callsite);

                                case 3:
                                    snapshot = _context2.sent;
                                    return _context2.abrupt('return', snapshot[prop]);

                                case 5:
                                case 'end':
                                    return _context2.stop();
                            }
                        }
                    }, _callee2, _this);
                }));

                return function get() {
                    return _ref2.apply(this, arguments);
                };
            }()
        });
    });

    obj.getStyleProperty = function () {
        var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(prop) {
            var callsite, snapshot;
            return _regenerator2.default.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                        case 0:
                            callsite = (0, _callsite.getCallsite)('getStyleProperty');
                            _context3.next = 3;
                            return getSnapshot(selector, callsite);

                        case 3:
                            snapshot = _context3.sent;
                            return _context3.abrupt('return', snapshot.style ? snapshot.style[prop] : void 0);

                        case 5:
                        case 'end':
                            return _context3.stop();
                    }
                }
            }, _callee3, _this);
        }));

        return function (_x3) {
            return _ref3.apply(this, arguments);
        };
    }();

    obj.getAttribute = function () {
        var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(attrName) {
            var callsite, snapshot;
            return _regenerator2.default.wrap(function _callee4$(_context4) {
                while (1) {
                    switch (_context4.prev = _context4.next) {
                        case 0:
                            callsite = (0, _callsite.getCallsite)('getAttribute');
                            _context4.next = 3;
                            return getSnapshot(selector, callsite);

                        case 3:
                            snapshot = _context4.sent;
                            return _context4.abrupt('return', snapshot.attributes ? snapshot.attributes[attrName] : void 0);

                        case 5:
                        case 'end':
                            return _context4.stop();
                    }
                }
            }, _callee4, _this);
        }));

        return function (_x4) {
            return _ref4.apply(this, arguments);
        };
    }();

    obj.getBoundingClientRectProperty = function () {
        var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(prop) {
            var callsite, snapshot;
            return _regenerator2.default.wrap(function _callee5$(_context5) {
                while (1) {
                    switch (_context5.prev = _context5.next) {
                        case 0:
                            callsite = (0, _callsite.getCallsite)('getBoundingClientRectProperty');
                            _context5.next = 3;
                            return getSnapshot(selector, callsite);

                        case 3:
                            snapshot = _context5.sent;
                            return _context5.abrupt('return', snapshot.boundingClientRect ? snapshot.boundingClientRect[prop] : void 0);

                        case 5:
                        case 'end':
                            return _context5.stop();
                    }
                }
            }, _callee5, _this);
        }));

        return function (_x5) {
            return _ref5.apply(this, arguments);
        };
    }();

    obj.hasClass = function () {
        var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(name) {
            var callsite, snapshot;
            return _regenerator2.default.wrap(function _callee6$(_context6) {
                while (1) {
                    switch (_context6.prev = _context6.next) {
                        case 0:
                            callsite = (0, _callsite.getCallsite)('hasClass');
                            _context6.next = 3;
                            return getSnapshot(selector, callsite);

                        case 3:
                            snapshot = _context6.sent;
                            return _context6.abrupt('return', snapshot.classNames ? snapshot.classNames.indexOf(name) > -1 : false);

                        case 5:
                        case 'end':
                            return _context6.stop();
                    }
                }
            }, _callee6, _this);
        }));

        return function (_x6) {
            return _ref6.apply(this, arguments);
        };
    }();
}
module.exports = exports['default'];